<?php
class Temas extends MY_Controller
{

function __construct(){
	parent::__construct();
	$this->load->model('themes_model');
}

function index(){
	$this->lista();
	}

function acceso_restringido() {
	$data['content']='acceso_restringido';
	$this->load->view('v_content',$data);
}

function check_access () {
	$this->load->library('sec_validation');
	$result = $this->sec_validation->login_check_access($this->session->userdata('usuario_id'),$this->router->fetch_class(),$this->router->fetch_method());
	if (!$result) {
	$this->session->set_flashdata('message_error', 'Acceso Restringido=>'.$this->router->fetch_class()."/".$this->router->fetch_method());
	redirect('usuarios/acceso_restringido');
	}
}

function lista(){
	// Valida Acceso
	$this->check_access();

	$data['temas'] = $this->themes_model->get_themes();
	$data['content']='admin/temas/lista';
	$this->load->view('v_content',$data);

	}

function ver($id= null){
	// Valida Acceso
	$this->check_access();

	// Sin parametro
	if (is_null($id)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_temas_msg_noexiste'));
		redirect('temas/lista');
	  }

	$tema = $this->themes_model->get_theme($id);
	// No existe
	if (empty($tema)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_temas_msg_noexiste'));
		redirect('temas/lista');
	  }
	$data['tema'] = $tema;
	$data['logs'] = $this->themes_model->get_theme_log($id);
	$data['content']='admin/temas/ver';
	$this->load->view('v_content',$data);

	}


	function editar($id= null,$origen="lista"){
	// Valida Acceso
	$this->check_access();

	// Sin parametro
	if (is_null($id)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_temas_msg_noexiste'));
		redirect('temas/lista');
	  }

	$tema = $this->themes_model->get_theme($id);
	// No existe
	if (empty($tema)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_temas_msg_noexiste'));
		redirect('temas/lista');
	  }

	$this->load->library('form_validation');

   if(isset($_POST["cancelar"])) {
		$this->session->set_flashdata('message', $this->lang->line('eap_temas_msg_cancelado'));
		if ($origen=="ver") { redirect('temas/ver/'.$id);} else {redirect('temas/lista');}
   }

	if (!empty($_POST))
	{
		$this->form_validation->set_rules('nombre', 'lang:eap_temas_nombre', 'required|trim|max_length[50]|xss_clean|callback_validar_unico['.$id.',nombre]');
		$this->form_validation->set_rules('graficos_nombre', 'lang:eap_temas_graficos_nombre', 'required|trim|max_length[50]|xss_clean|callback_validar_unico['.$id.',graficos_nombre]');
		$this->form_validation->set_rules('graficos_nombre_pt', 'lang:eap_temas_graficos_nombre_pt', 'required|trim|max_length[50]|xss_clean|callback_validar_unico['.$id.',graficos_nombre_pt]');
		$this->form_validation->set_rules('graficos_nombre_en', 'lang:eap_temas_graficos_nombre_en', 'required|trim|max_length[50]|xss_clean|callback_validar_unico['.$id.',graficos_nombre_en]');

		$this->form_validation->run();
	}

   if($this->form_validation->run()){

		$historial='';

		if($this->input->post('nombre') != $tema['nombre']) {$data['nombre'] = $this->input->post('nombre');$historial.="Nombre@@$tema[nombre]@@$data[nombre]||";}
		if($this->input->post('graficos_nombre') != $tema['graficos_nombre']) {$data['graficos_nombre'] = $this->input->post('graficos_nombre');$historial.="Nombre para Graficos@@$tema[graficos_nombre]@@$data[graficos_nombre]||";}
		if($this->input->post('graficos_nombre_pt') != $tema['graficos_nombre_pt']) {$data['graficos_nombre_pt'] = $this->input->post('graficos_nombre_pt');$historial.="Nombre para Graficos PT@@$tema[graficos_nombre_pt]@@$data[graficos_nombre_pt]||";}
		if($this->input->post('graficos_nombre_en') != $tema['graficos_nombre_en']) {$data['graficos_nombre_en'] = $this->input->post('graficos_nombre_en');$historial.="Nombre para Graficos EN@@$tema[graficos_nombre_en]@@$data[graficos_nombre_en]||";}

		if ($historial != '') {$data['fecha'] = date("Y-m-d H:i:s");}

		if ($historial != '' && $this->themes_model->set_theme($id, $data)){
			// GUARDA LOG
			$data_log = array(
				'id_temas' => $id,
				'fecha' => date("Y-m-d H:i:s"),
				'modificador' => $this->session->userdata('usuario_nombre_apellido'),
				'modificaciones' => $historial);
			if ($historial != '') {$this->themes_model->set_theme_log($data_log);}
			$this->session->set_flashdata('message', $this->lang->line('eap_temas_msg_guardado'));
			if ($origen=="ver") { redirect('temas/ver/'.$id);} else {redirect('temas/lista');}
			//echo $this->db->last_query();
		} else {
			$this->session->set_flashdata('message', $this->lang->line('eap_temas_msg_guardado_error'));
		}
   }


	$data['origen']= $origen;
	$data['tema'] = $tema;
	$data['logs'] = $this->themes_model->get_theme_log($id);
	$data['content']='admin/temas/editar';
	$this->load->view('v_content',$data);

	}

function nuevo(){
	// Valida Acceso
	$this->check_access();

	$this->load->library('form_validation');

   if(isset($_POST["cancelar"])) {
		$this->session->set_flashdata('message', $this->lang->line('eap_temas_msg_cancelado_nuevo'));
		redirect('temas/lista');
   }

	if (!empty($_POST))
	{
		$this->form_validation->set_rules('nombre', 'lang:eap_temas_nombre', 'required|trim|max_length[50]|xss_clean|callback_validar_unico');
		$this->form_validation->set_rules('graficos_nombre', 'lang:eap_temas_graficos_nombre', 'required|trim|max_length[50]|xss_clean|callback_validar_unico[null,graficos_nombre]');
		$this->form_validation->set_rules('graficos_nombre_pt', 'lang:eap_temas_graficos_nombre_pt', 'required|trim|max_length[50]|xss_clean|callback_validar_unico[null,graficos_nombre_pt]');
		$this->form_validation->set_rules('graficos_nombre_en', 'lang:eap_temas_graficos_nombre_en', 'required|trim|max_length[50]|xss_clean|callback_validar_unico[null,graficos_nombre_en]');

		$this->form_validation->run();
	}

   if($this->form_validation->run()){
		$historial='';
		$data['fecha'] = date("Y-m-d H:i:s");
		if($this->input->post('nombre') != "") {$data['nombre'] = $this->input->post('nombre');$historial.="Nombre@@@@$data[nombre]||";}
		if($this->input->post('graficos_nombre') != "") {$data['graficos_nombre'] = $this->input->post('graficos_nombre');$historial.="Nombre para Graficos@@@@$data[graficos_nombre]||";}
		if($this->input->post('graficos_nombre_pt') != "") {$data['graficos_nombre_pt'] = $this->input->post('graficos_nombre_pt');$historial.="Nombre para Graficos PT@@@@$data[graficos_nombre_pt]||";}
		if($this->input->post('graficos_nombre_en') != "") {$data['graficos_nombre_en'] = $this->input->post('graficos_nombre_en');$historial.="Nombre para Graficos EN@@@@$data[graficos_nombre_en]||";}

		$id=$this->themes_model->set_theme('', $data,'insert');

		if (is_numeric($id)){
			// Guardar LOG de Modificacion
			$data_log = array(
				'id_temas' => $id,
				'fecha' => date("Y-m-d H:i:s"),
				'modificador' => $this->session->userdata('usuario_nombre_apellido'),
				'modificaciones' => $historial);
			$this->themes_model->set_theme_log($data_log);

			$this->session->set_flashdata('message', $this->lang->line('eap_temas_msg_guardado'));
			redirect('temas/ver/'.$id);
			//echo $this->db->last_query();
		} else {
			$this->session->set_flashdata('message', $this->lang->line('eap_temas_msg_guardado_error'));
		}
   }


	$tema = array(
		'nombre'=>'',
		'graficos_nombre'=>'',
		'graficos_nombre_pt'=>'',
		'graficos_nombre_en'=>''
	);

	$data['tema'] = $tema;
	$data['content']='admin/temas/nuevo';
	$this->load->view('v_content',$data);

	}

function validar_unico ($nombre=null,$id=null,$campo=null){
   if ($this->themes_model->is_unique($nombre,$id,$campo)) {
	   return TRUE;
   } else {
	   $this->form_validation->set_message('validar_unico', $this->lang->line('eap_temas_msg_validar_unico').'==>'.$nombre.'ID=>'.$id);
	   return FALSE;
   }
}

function borrar ($id=null){
	// Valida Acceso
	$this->check_access();

	if (is_null($id)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_temas_msg_guardado_estado_error'));
		redirect('temas/lista');
	}

	$this->session->set_flashdata('message', $this->lang->line('eap_temas_msg_borrado'));

	if (!$this->themes_model->delete_theme($id)) { $this->session->set_flashdata('message', $this->lang->line('eap_temas_msg_guardado_estado_error')); }
	redirect('temas/lista');


}

}
